CREATE OR REPLACE FUNCTION Taqnyat_SOAP_Send_SMS(p_userName IN varchar2 ,
p_password IN varchar2 ,
p_numbers IN varchar2 ,
p_sender IN varchar2 ,
p_message IN varchar2 ,
p_dateSend IN varchar2 ,
p_timeSend IN varchar2 ,
p_deleteKey IN varchar2 ,
p_messageId IN varchar2 ,
p_applicationType IN varchar2 ,
p_domainName IN varchar2,
p_lang IN varchar2,
p_notRepeat IN varchar2 )

RETURN varchar2
AS
l_request SYSTEM.soap_api.t_request;
l_response SYSTEM.soap_api.t_response;
l_return VARCHAR2(32767);

l_url VARCHAR2(32767);
l_namespace VARCHAR2(32767);
l_method VARCHAR2(32767);
l_soap_action VARCHAR2(32767);
l_result_name VARCHAR2(32767);
BEGIN
l_url := 'http://webservice.taqnyat.sa/SMS-N/SMS.asmx?WSDL';
l_namespace := 'xmlns="http://tempuri.org/"';
l_method := 'SendSMSWithLangAndNotRepeat';
l_soap_action := 'http://tempuri.org/SendSMSWithLangAndNotRepeat';
l_result_name := 'SendSMSWithLangAndNotRepeatResult';

l_request := system.soap_api.new_request(p_method => l_method,
p_namespace => l_namespace);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'userName',
p_type => 'xsd:string',
p_value => p_userName);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'password',
p_type => 'xsd:string',
p_value => p_password);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'numbers',
p_type => 'xsd:string',
p_value => p_numbers);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'sender',
p_type => 'xsd:string',
p_value => p_sender);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'message',
p_type => 'xsd:string',
p_value => p_message);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'dateSend',
p_type => 'xsd:string',
p_value => p_dateSend);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'timeSend',
p_type => 'xsd:string',
p_value => p_timeSend);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'deleteKey',
p_type => 'xsd:string',
p_value => p_deleteKey);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'messageId',
p_type => 'xsd:string',
p_value => p_messageId);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'applicationType',
p_type => 'xsd:string',
p_value => p_applicationType);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'domainName',
p_type => 'xsd:string',
p_value => p_domainName);

---New added----------
system.soap_api.add_parameter(p_request => l_request,
p_name => 'lang',
p_type => 'xsd:string',
p_value => p_lang);

system.soap_api.add_parameter(p_request => l_request,
p_name => 'notRepeat',
p_type => 'xsd:string',
p_value => p_notRepeat);
------------------------------

l_response := system.soap_api.invoke(p_request => l_request,
p_url => l_url,
p_action => l_soap_action);
l_return := system.soap_api.get_return_value(p_response => l_response,
p_name => l_result_name,
p_namespace => l_namespace);
l_return := replace (l_return,'&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;Taqnyat&gt;&lt;Status&gt;') ;
l_return := replace (l_return,'&lt;/Status&gt;&lt;/Taqnyat&gt;') ; 
RETURN l_return;
END;

---------------------------------------------------------------------------------------------------
 
