CREATE OR REPLACE FUNCTION Taqnyat_SOAP_Delete_Scedule_SMS(p_userName IN varchar2 ,
p_password IN varchar2 ,
p_deleteKey IN varchar2 
)

RETURN varchar2
AS
l_request SYSTEM.soap_api.t_request;
l_response SYSTEM.soap_api.t_response;
l_return VARCHAR2(32767);

l_url VARCHAR2(32767);
l_namespace VARCHAR2(32767);
l_method VARCHAR2(32767);
l_soap_action VARCHAR2(32767);
l_result_name VARCHAR2(32767);
BEGIN
l_url := 'http://webservice.taqnyat.sa/SMS-N/SMS.asmx?WSDL';
l_namespace := 'xmlns="http://tempuri.org/"';
l_method := 'DeleteScheduleMessage';
l_soap_action := 'http://tempuri.org/DeleteScheduleMessage';
l_result_name := 'DeleteScheduleMessageResult';

l_request := system.soap_api.new_request(p_method => l_method,
p_namespace => l_namespace);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'userName',
p_type => 'xsd:string',
p_value => p_userName);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'password',
p_type => 'xsd:string',
p_value => p_password);
system.soap_api.add_parameter(p_request => l_request,
p_name => 'deleteKey',
p_type => 'xsd:string',
p_value => p_deleteKey);


l_response := system.soap_api.invoke(p_request => l_request,
p_url => l_url,
p_action => l_soap_action);
l_return := system.soap_api.get_return_value(p_response => l_response,
p_name => l_result_name,
p_namespace => l_namespace);
l_return := replace (l_return,'&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;Taqnyat&gt;&lt;Status&gt;') ;
l_return := replace (l_return,'&lt;/Status&gt;&lt;/Taqnyat&gt;') ; 
RETURN l_return;
END;

---------------------------------------------------------------------------------------------------
 
